#!/usr/bin/perl

use strict;
use warnings;
use Data::Dumper;

#pos opens
open (my $abcp, "<", "out.abcpredNR_exact.pos.txt") or die "Can't open file : $!";
open (my $bcep, "<", "out.bce2NR_exact.pos.txt") or die "Can't open file : $!";
open (my $bepp, "<", "out.bepiNR_exact.pos.txt") or die "Can't open file : $!";
open (my $lbtp, "<", "out.lbtopeNR_exact.pos.txt") or die "Can't open file : $!";
#open (my $lbep, "<", "out.lbeepNR.pos.B.txt") or die "Can't open file : $!";
open (my $svmp, "<", "out.SVMTNR_exact.pos.txt") or die "Can't open file : $!";
open (my $cobp, "<", "out.CobeproNR_exact.pos.txt") or die "Can't open file : $!";

#neg opens
open (my $abcn, "<", "out.abcpredNR_exact.neg.txt") or die "Can't open file : $!";
open (my $bcen, "<", "out.bce2NR_exact.neg.txt") or die "Can't open file : $!";
open (my $bepn, "<", "out.bepiNR_exact.neg.txt") or die "Can't open file : $!";
open (my $lbtn, "<", "out.lbtopeNR_exact.neg.txt") or die "Can't open file : $!";
#open (my $lben, "<", "out.lbeepNR.neg.B.txt") or die "Can't open file : $!";
open (my $svmn, "<", "out.SVMTNR_exact.neg.txt") or die "Can't open file : $!";
open (my $cobn, "<", "out.CobeproNR_exact.neg.txt") or die "Can't open file : $!";

#pos array opens
my @pabc;
my @pbce;
my @pbep;
my @plbt;
#my @plbe;
my @psvm;
my @pcob;


#neg array opens
my @nabc;
my @nbce;
my @nbep;
my @nlbt;
#my @nlbe;
my @nsvm;
my @ncob;

#READ FILES

#abcpred!!!
while(<$abcp>)
{
    if(/^\d+\t\w+\t\S+\tE/)
    {
        push (@pabc,"E");
		#print "1";
    }  
	else
	{
		push (@pabc,"-");
		#print "1";
	}
}    
#print scalar @pabc;
close $abcp;

while(<$abcn>)
{
    if(/^\d+\t\w+\t\S+\tE/)
    {
        push (@nabc,"E");
    }  
	else
	{
		push (@nabc,"-");
	} 
}  
#print scalar @nabc;
close $abcn;

#bcepred!!!
$/="//";

while(<$bcep>)
{
	my @lines;
	
    while(/^\d+\t\w\t\S+\t(\S)/mg)
    {
		push (@lines,$1);
		#print $1;
    } 
	push (@pbce,\@lines);
}    
#print scalar @pbce;
close $bcep;

while(<$bcen>)
{
	my @lines;
	
    while(/^\d+\t\w\t\S+\t(\S)/mg)
    {
		push (@lines,$1);
		#print $1;
    } 
	push (@nbce,\@lines);
}  
#print scalar @nbce;
close $bcen;

#bepipred!!!
while(<$bepp>)
{
	my @lines;
	
    while(/^\d+\t\w\t\S+\t(\S)/mg)
    {
		push (@lines,$1);
		#print $1;
    } 
	push (@pbep,\@lines);
}    
#print scalar @pbep;
close $bepp;

while(<$bepn>)
{
	my @lines;
	
    while(/^\d+\t\w\t\S+\t(\S)/mg)
    {
		push (@lines,$1);
		#print $1;
    } 
	push (@nbep,\@lines);
}  
#print scalar @nbep;
close $bepn;

#lbtope!!!
while(<$lbtp>)
{
	my @lines;
	
    while(/^\w+\t\S+\t(\S+)\t\S+/mg)
    {
		push (@lines,$1);
		#print $1;
    } 
	push (@plbt,\@lines);
}    
#print scalar @plbt;
close $lbtp;

while(<$lbtn>)
{
	my @lines;
	
    while(/^\w+\t\S+\t(\S+)\t\S+/mg)
    {
		push (@lines,$1);
		#print $1;
    } 
	push (@nlbt,\@lines);
}  
#print scalar @nlbt;
close $lbtn;

=pod
#Lbeep!!!
$/="\n";

while(<$lbep>)
{
    if(/\d+,>\w+\|\w+\|,(\S+)/)
    {
		if($1>=0.6)
		{
			push(@plbe,"E");
		}
		else
		{
			push(@plbe,"-");
		}
	}
}    
#print scalar @plbe;
close $lbep;

while(<$lben>)
{
    if(/\d+,>\w+\|\w+\|,(\S+)/)
    {
		if($1>=0.6)
		{
			push(@nlbe,"E");
		}
		else
		{
			push(@nlbe,"-");
		}
	}
}    
#print scalar @nlbe;
close $lben;
=cut

#SVMTrip!!!
$/="\n";
while(<$svmp>)
{
    if(/^\d+\t1 - 20,\s\w+,\s\S+\t(\S)/)
    {
		push(@psvm,$1);
	}
}    
#print Dumper(@psvm);
close $svmp;

while(<$svmn>)
{
    if(/^\d+\t1 - 20,\s\w+,\s\S+\t(\S)/)
    {
		push(@nsvm,$1);
	}
}    
#print Dumper(@nsvm);
close $svmn;

#COBEpro!!!
$/="//\n";

while(<$cobp>)
{
	my @lines;
	
    if(/^\w+\t\n\w+\n(\S+)\n/)
    {
		@lines= split "",$1;
		#print $1;
    } 
	push (@pcob,\@lines);
}    
#print Dumper(@pcob);
close $cobp;

while(<$cobn>)
{
	my @lines;
	
    if(/^\w+\t\n\w+\n(\S+)\n/)
    {
		@lines= split "",$1;
		#print $1;
    } 
	push (@ncob,\@lines);
}  
#print Dumper(@ncob);
close $cobn;



#PREDICTION


#POSITIVE
my @poscount;

foreach my $i(0..$#psvm)
{
	my @twenty;
	
	for(my $j=0;$j<20;$j++)
	{
		push(@twenty,0);
	}
	push (@poscount,\@twenty);
}


foreach my $i(0..$#psvm)
{
	
	#bce,cobe,lbt,bepi
	for(my $j=0;$j<20;$j++)
	{
		#aminoacid
		if($pbce[$i][$j] eq "E")					#bcepred
		{
			$poscount[$i][$j]++;
		}
		
		if($pcob[$i][$j] >= 4)						#cobepro
		{
			$poscount[$i][$j]++;
		}
		
		if($plbt[$i][$j] eq "Epitope")				#lbtope
		{
			$poscount[$i][$j]++;
		}
		
		if($pbep[$i][$j] eq "E")					#bepipred
		{
			$poscount[$i][$j]++;
		}
		
		#models
		if($pabc[$i] eq "E")						#abcpred
		{
			$poscount[$i][$j]++;
		}
#		if($plbe[$i] eq "E")						#lbeep
#		{
#			$poscount[$i][$j]++;
#		}
		if($psvm[$i] eq "E")						#svmtrip
		{
			$poscount[$i][$j]++;
		}
	}
}
#print Dumper(@poscount);

#NEGATIVE
my @negcount;

foreach my $i(0..$#nsvm)
{
	my @twenty;
	
	for(my $j=0;$j<20;$j++)
	{
		push(@twenty,0);
	}
	push (@negcount,\@twenty);
}
#print Dumper(@negcount);

foreach my $i(0..$#nsvm)
{
	
	#bce,cobe,lbt,bepi
	for(my $j=0;$j<20;$j++)
	{
		#aminoacid
		if($nbce[$i][$j] eq "E")					#bcepred
		{
			$negcount[$i][$j]++;
		}
		
		if($ncob[$i][$j] >= 4)						#cobepro
		{
			$negcount[$i][$j]++;
		}
		
		if($nlbt[$i][$j] eq "Epitope")				#lbtope
		{
			$negcount[$i][$j]++;
		}
		
		if($nbep[$i][$j] eq "E")					#bepipred
		{
			$negcount[$i][$j]++;
		}
		
		#models
		if($nabc[$i] eq "E")						#abcpred
		{
			$negcount[$i][$j]++;
		}
#		if($nlbe[$i] eq "E")						#lbeep
#		{
#			$negcount[$i][$j]++;
#		}
		if($nsvm[$i] eq "E")						#svmtrip
		{
			$negcount[$i][$j]++;
		}
	}
}
#print Dumper(@negcount);



#EVALUATION



my @pscores;

foreach my $i(0..$#psvm)
{
	my $count=0;
	
	for(my $j=0;$j<20;$j++)
	{
		
		if($poscount[$i][$j]>=3)			#consensus positive threshold
		{
			$count++;
		}
		
	}
	push(@pscores,$count);
}

#print Dumper(@pscores);

my @nscores;

foreach my $i(0..$#nsvm)
{
	my $count=0;
	
	for(my $j=0;$j<20;$j++)
	{
		
		if($negcount[$i][$j]>=3)			#consensus positive threshold
		{
			$count++;
		}
		
	}
	push(@nscores,$count);
}

#print Dumper(@nscores);

#STATISTICS



my $tp= 0;
my $tn= 0;
my $fp= 0;
my $fn= 0;

my $tpaa= 0;
my $tnaa= 0;
my $fpaa= 0;
my $fnaa= 0;

foreach my $i (0 .. $#pscores)
{
	#print $pscores[$i];
	if($pscores[$i] >= 10)				#aminoacid positive threshold
	{	
		$tp++;
	}
	else
	{	
		$fn++;
	}
	$tpaa=$tpaa + $pscores[$i];
	$fnaa=$fnaa + (20 - $pscores[$i]);
	
}

foreach my $i (0 .. $#nscores)
{
	if($nscores[$i] < 10)				#aminoacid negative threshold
	{
		$tn++;
	}
	else
	{
		$fp++;
	}
	$fpaa=$fpaa + $nscores[$i];
	$tnaa=$tnaa + (20 - $nscores[$i]);
}

my $sn= $tp/($tp+$fn);
my $sp= $tn/($tn+$fp);
my $acc= ($tp+$tn)/($tp+$fp+$tn+$fn);
my $mcc= (($tp*$tn)-($fp*$fn))/sqrt(($tp+$fp)*($tp+$fn)*($tn+$fp)*($tn+$fn));
my $posnum= $tp+$fn;
my $negnum= $tn+$fp;

my $snaa= $tpaa/($tpaa+$fnaa);
my $spaa= $tnaa/($tnaa+$fpaa);
my $accaa= ($tpaa+$tnaa)/($tpaa+$fpaa+$tnaa+$fnaa);
my $mccaa= (($tpaa*$tnaa)-($fpaa*$fnaa))/sqrt(($tpaa+$fpaa)*($tpaa+$fnaa)*($tnaa+$fpaa)*($tnaa+$fnaa));


open ( OUT, ">", "Consensus.STATS.txt");

print OUT "POSITIVE:$posnum\tNEGATIVE:$negnum\n\n";

print OUT ">= 50% OF SEQUENCE\n";
print OUT "TP\t$tp\nTN\t$tn\nFP\t$fp\nFN\t$fn\n\n";
print OUT "SEN\t$sn\nSPE\t$sp\nACC\t$acc\nMCC\t$mcc\n\n";

print OUT "PER AMINOACID\n";
print OUT "TP\t$tpaa\nTN\t$tnaa\nFP\t$fpaa\nFN\t$fnaa\n\n";
print OUT "SEN\t$snaa\nSPE\t$spaa\nACC\t$accaa\nMCC\t$mccaa";